#include <XBee.h>
#include <SoftwareSerial.h>

XBee xbee = XBee();

uint8_t payload[80];

//String macHigh="0013A200";
//String macLow="40762056";
String data="";

// serial high
uint8_t shCmd[] = {'S','H'};
// serial low
uint8_t slCmd[] = {'S','L'};

AtCommandRequest atRequest = AtCommandRequest();
AtCommandResponse atResponse = AtCommandResponse();

void setup() {
  
  xbee.begin(38400);
  
  Serial.begin(38400);
  Serial.println("Arduino. Will send packets.");
  
  data += "Arduino test from -mac:";
    
  // set command to SH to get high part of MAC address
  atRequest.setCommand(shCmd);  
  while (!sendAtCommand()) {Serial.println("retry command ATSH");};
 
  char adr_part[8];
  String adr="";
  
  // get each value, convert in to string and append to the adr
  for (int i = 0; i < atResponse.getValueLength(); i++) {
    Serial.print(atResponse.getValue()[i], HEX);
    Serial.print(" ");
    sprintf(adr_part, "%lX", (unsigned long)(atResponse.getValue()[i]));
    
    if (atResponse.getValue()[i]<=0xF) 
        adr += 0;
        
    adr += adr_part;
    
  } 

  Serial.println(adr);

  // set command to SL to get low part of MAC address
  atRequest.setCommand(slCmd);  
  while (!sendAtCommand()) {Serial.println("retry command ATSL");};
  
  for (int i = 0; i < atResponse.getValueLength(); i++) {
    Serial.print(atResponse.getValue()[i], HEX);
    Serial.print(" ");
    sprintf(adr_part, "%lX", (unsigned long)(atResponse.getValue()[i]));
    
    if (atResponse.getValue()[i]<=0xF) 
        adr += 0;
        
    adr += adr_part;
    
  } 
  
  Serial.println(adr);
  
  // data is now appended with the MAC address  
  data += adr;
}

void loop() {
  
  delay(5000);
    
  // 64-bit addressing: This is the SH + SL address of remote XBee
  XBeeAddress64 addr64 = XBeeAddress64(0x00000000, 0x0000FFFF);
  // unless you have MY on the receiving radio set to FFFF, this will be received as a RX16 packet
  
  for (int i; i<data.length(); i++)
    payload[i]=(uint8_t)data.charAt(i);
  
  // in this way, we know the exact size of the payload
  Tx64Request tx = Tx64Request(addr64, payload, data.length());
  
  // Send your request
  xbee.send(tx);

  TxStatusResponse txStatus = TxStatusResponse();
}

// used here to sens AT command to the Xbee to get information such as the MAC address
int sendAtCommand() {
  Serial.println("Sending command to the XBee");

  // send the command
  xbee.send(atRequest);

  // wait up to 5 seconds for the status response
  if (xbee.readPacket(5000)) {
    // got a response!

    // should be an AT command response
    if (xbee.getResponse().getApiId() == AT_COMMAND_RESPONSE) {
      xbee.getResponse().getAtCommandResponse(atResponse);

      if (atResponse.isOk()) {
        Serial.print("Command [");
        Serial.print(atResponse.getCommand()[0]);
        Serial.print(atResponse.getCommand()[1]);
        Serial.println("] was successful!");

        if (atResponse.getValueLength() > 0) {
          Serial.print("Command value length is ");
          Serial.println(atResponse.getValueLength(), DEC);

          Serial.print("Command value: ");
          
          for (int i = 0; i < atResponse.getValueLength(); i++) {
            Serial.print(atResponse.getValue()[i], HEX);
            Serial.print(" ");
          }

          Serial.println("");
        }
        return 1;
      } 
      else {
        Serial.print("Command return error code: ");
        Serial.println(atResponse.getStatus(), HEX);
      }
    } else {
      Serial.print("Expected AT response but got ");
      Serial.print(xbee.getResponse().getApiId(), HEX);
    }   
  } else {
    // at command failed
    if (xbee.getResponse().isError()) {
      Serial.print("Error reading packet.  Error code: ");  
      Serial.println(xbee.getResponse().getErrorCode());
    } 
    else {
      Serial.print("No response from radio");  
    }
  }
  return 0;
}
